
/**********************************************************
 *
 *   Function CDPlayer () -> lCDIsPlaying
 *   Demo for all CD-Functions and a complete ready-tu-use
 *   CD-Player for your Application also.
 *
 */

  #include "SOUNDVIS.CH"
  #include "INKEY.CH"


  // CD-Player Colors
  #define  F_LGN       10               // BriGreen on Black
  #define  F_NGR      143               // BriWhite on grey
  #define  F_LRGR     140               // BriRed   on grey
  #define  F_YGR      142               // Yellow   on Grey
  #define  F_GN         2               // Green    on black
  #define  F_NG        32               // Black    on Green
  #define  F_WBLUE     31               // LiteWhite on Blue
  #define  F_NHB       48               // Black on LiteBlue
  #define  F_NW       112               // Black on White
  #define  F_RW       116               // Red on White
  #define  F_WBROWN   191               // LiteWhite on Brown (converted)
  #define  F_NBEIGE   208               // black on Beige     (converted)
  #define  F_RBEIGE   212               // red on Beige       (converted)


  // CD-Player Events
  #define CD_EXITUS     0
  #define CD_WINDOW     1
  #define CD_UPDATE     2
  #define CD_PLAY       3
  #define CD_PAUSE      4
  #define CD_BUTTON     5
  #define CD_STOP       6
  #define CD_INKEY      7
  #define CD_NEXT       8
  #define CD_PREVIOUS   9
  #define CD_MOVE      10
  #define CD_CHANGE    11
  #define CD_INC       12
  #define CD_DEC       13

  #define STD_INFO 'N/*RB,N/W,,,R/*RB'


  FUNCTION CDPlayer ()



     // WindowCorners
     LOCAL nTRow := 8, nLCol := 5, nBRow := 18, nRCol := 73

     // Control Panel
     STATIC aCd := {'','','','','','','','Power'}

     // Choice begins at
     LOCAL nChoice := 2 , nX, nY, nKey
     
     LOCAL cOldColor := SETCOLOR ( STD_INFO ), oScreen, o2Screen

     LOCAL nTrack := GetTrackCD( 0 )

     LOCAL nLastTrack, nFirstTrack, aVolume

     LOCAL nEvent := CD_WINDOW

     LOCAL GetList := {}


     // Live : All happens within one big loop
     // --------------------------------------
     DO WHILE nEvent # CD_EXITUS

        DO CASE
          // -----------------------
          // Build CD-Player's Image
          // -----------------------
        CASE nEvent == CD_WINDOW

             OPENWIN FROM nTRow,nLCol TO nbRow,nRCol  ;
                          TOPCOLOR F_NW               ;
                          WINCOLOR F_NGR              ;
                          TITLE 'CD-PLAYER'           ;
                          TYP WIN_MESSBUT             ;
                          SAVE TO oScreen   

             // CD-Display
             OutFrame ( nTRow+2, nLCol+4, nBRow-4, nLCol+40, 2 )
             ColorMe  ( nTRow+2, nLCol+4, nBRow-4, nLCol+40, F_GN )

             // Disk-Caddy
             OutLine  ( nTRow+2, nLCol+43,'    SOUND & VISION    ', 1, F_YGR)

             // Volume Fader
             ShowStr( 4, 51, '-',, .t.)
             ShowStr( 4, 65, '+',, .t.)
             ShowStr( 5, 43, 'Vol L', F_YGR , .t.)
             ShowStr( 6, 43, 'Vol R', F_YGR , .t.)


             // LED-Display
             ShowStr ( 2,  5, 'Track',, .t.)
             ShowStr ( 2, 24, 'Time',,  .t.)
             ShowStr ( 3, 24, 'Song',,  .t.)
             ShowStr ( 4,  5, 'Drive',, .t.)
             ShowStr ( 4, 24, 'Disc',,  .t.)


             // Create Button Object
             aBinBut := oAddButt ( nBRow-1, nLCol+3, F_NW, F_RW, aCD, .f. )

             // Display Button Object
             oDisButt ( aBinBut, nChoice )

             // Next stop is at ..
             nEvent := CD_CHANGE

          // ---------------------
          // Update Status-Display
          // ---------------------
        CASE nEvent == CD_UPDATE

             // Volume
             aVolume := GetSbVol( CH_CD )

             FOR nX := 5 TO 6
                 HLinie ( nTRow + nX, nLCol+ 51, nLCol+66,'',128)
                 ShowStr ( nX, aVolume[nX-4]+50, '',, .t.)

             NEXT

             // Some lurk has changed the cd ?
             IF ChangedCD()
                nEvent := CD_CHANGE

             ELSE

                IF GetPauseCD()
                   ShowStr ( 3, 5, 'PAUSE',F_NG, .t.)
                ELSE
                   ShowStr ( 3, 5, '     ',F_GN, .t.)
                ENDIF

                nTrack := GetTrackCD(0)

                // TrackNumber as String
                ShowStr ( 2, 12, GetTrackCD (4), F_LGN, .t.)

                // PlayTime
                ShowStr ( 2, 32, RunTimeCD ( ) , F_LGN, .t. )

                // Song Time
                ShowStr ( 3, 32, GetVolCD( nTrack ), F_LGN, .t.)

                nEvent := CD_INKEY

             ENDIF

          // ------------------
          // New Media inserted
          // ------------------
        CASE nEvent == CD_CHANGE
             nDrive := InitCD()

             // Show Total DiscTime
             ShowStr ( 4, 32, GetVolCD(-1), F_LGN, .t.)

             // Aktive Drive
             ShowStr ( 4, 10, STR(nDrive, 2), F_LGN , .t.)

             nFirstTrack := GetTrackCD(1)
             nLastTrack  := GetTrackCD(2)


             // TrackNumbers: aktive Tracks in LightRed
             FOR nX := 1 TO 9
                 nY := nX * 4

                 ShowStr ( 5, nY, STR (nX   ,3),;
                           IIF( nX >= nFirstTrack .AND. ;
                                nX <= nLastTrack , 12, 4 ), .t.)

                 ShowStr ( 6, nY,  STR (nX+9 ,3), ;
                           IIF( nX+9 >= nFirstTrack .AND.;
                                nX+9 <= nLastTrack , 12, 4), .t.)

             NEXT

             // Next stop is at:
             nEvent := IIF(nLastTrack > nFirstTrack, CD_UPDATE, CD_INKEY)

          // -------------
          // Poll Keyboard
          // -------------
        CASE nEvent == CD_INKEY
             MSE_Show ( .t. )
             nKey := INKEY(.5)
             MSE_Show ( .f. )

             // Preset next step
             nEvent := CD_UPDATE

             IF nKey # 0

               // Scan KeyCode
               DO CASE 
               CASE nKey == K_MOUSE

                     DO CASE

                       // Mouse over Button ?
                     CASE ( nX := oMouseButt( aBinBut)) # 0
                          nChoice := oSetFocus ( aBinBut, nX )
                          nEvent  := CD_BUTTON

                       // Mouse over Icon ?
                     CASE ( nX := oMouseWin ()) # 0
                          IF nX == M_CLOSE
                             nEvent := CD_EXITUS

                          ELSE
                             nEvent := CD_MOVE

                          ENDIF

                       // Volume Left ?
                     CASE MSE_Check ( 5, 51, 5, 66, .t.)
                          aVolume[1] := (MSE_Col () - 55 )
                          SetSbVol ( CH_CD, aVolume )


                       // Volume Right ?
                     CASE MSE_Check ( 6, 51, 6, 66, .t.)
                          aVolume[2] := (MSE_Col () - 55 )
                          SetSbVol ( CH_CD, aVolume )


                       // Tracknumbers ?
                     OTHERWISE
                          nMouseRow := MSE_Row()
                          nMouseCol := MSE_Col()

                          // Hit the Track-Index ?
                          IF Mse_Check( 5, 4, 6, 38, .t. )

                             // Yes, but which Track ...
                             FOR nY := nLCol+4 TO nLCol+36  STEP 4

                                 IF nMouseCol >= nY .AND. nMouseCol <= nY+2
                                    nY := (nY-5)/4
                                    nY := IIF( nMouseRow == nTRow+5,;
                                                             nY, nY+9 )

                                    IF nY >= nFirstTrack .AND. ;
                                       nY <= nLastTrack

                                       nTrack := nY
                                       nEvent := CD_PLAY
                                       EXIT

                                    ENDIF
                                 ENDIF
                             NEXT
                          ENDIF
                     ENDCASE

                  // HotKey ?
                CASE (nX := oKeyButt ( aBinBut, nKey )) # 0
                      nChoice := oSetFocus ( aBinBut, nX )
                      nEvent  := CD_BUTTON


                CASE nKey == K_LEFT  .OR. nKey == K_DOWN .OR. ;
                     nKey == K_RIGHT .OR. nKey == K_UP

                     nChoice := oSetFocus ( aBinBut, WrapWert          ;
                                   ( nKey == K_RIGHT .OR. nKey == K_UP,;
                                          nChoice, 1, 8 ))

                CASE nKey == K_HOME
                     nChoice := oSetFocus ( aBinBut, 1 )


                CASE nKey == K_END
                     nChoice := oSetFocus ( aBinBut, 8 )


                CASE nKey == K_ESC
                     nChoice := oSetFocus ( aBinBut, 8 )
                     nEvent :=  CD_EXITUS

                CASE nKey == K_ENTER
                     nEvent :=  CD_BUTTON

                CASE nKey == 45 // minus -> STEP 2 !!
                     aVolume[1] := MAX(1, aVolume[1]-2)
                     aVolume[2] := aVolume[1]
                     SetSbVol ( CH_CD, aVolume )

                CASE nKey == 43  // plus
                     aVolume[1] := MIN(15, aVolume[1]+1)
                     aVolume[2] := aVolume[1]
                     SetSbVol ( CH_CD, aVolume )

               OTHERWISE
                     nKey   := 0

                ENDCASE

             ENDIF

          // ---------------
          // Activate Button
          // ---------------
        CASE nEvent == CD_BUTTON
             nChoice := oPushButt ( aBinBut )

          // Check for Action
             DO CASE
             CASE nChoice == 1
                  nEvent := CD_PREVIOUS

             CASE nChoice == 2
                  nEvent := CD_PLAY

             CASE nChoice == 3
                  nEvent := CD_NEXT

             CASE nChoice == 4
                  nEvent := CD_INC

             CASE nChoice == 5
                  nEvent := CD_PAUSE

             CASE nChoice == 6
                  nEvent := CD_STOP
                  
             CASE nChoice == 7
                  nEvent := CD_DEC

             CASE nChoice == 0 .OR. ;
                  nChoice == 8
                  nEvent := CD_EXITUS

             OTHERWISE
                  nEvent := CD_UPDATE

             ENDCASE

          // ----------------------------------
          // We have to move this Refridgerator, 
          // we have to move this Color-TV ...
          // -----------------------------------
        CASE nEvent == CD_MOVE
             nTRow := IIF ( nTRow ==  8, 0, 8)
             nLCol := IIF ( nLCol ==  5, 0, 5)
             nBRow := IIF ( nBRow == 18,10,18)
             nRCol := IIF ( nRCol == 73,68,73)
             ScrRest ( oScreen )

             nEvent := CD_WINDOW


          // --------------------------
          // Play Next / Previous Track
          // --------------------------
        CASE nEvent == CD_NEXT .OR. nEvent == CD_PREVIOUS
             nTrack := SkipCd(nEvent == CD_NEXT)
             nEvent := CD_UPDATE

          // ------------------------
          // Incremet/Decrement Track
          // ------------------------
        CASE nEvent == CD_INC .OR. nEvent == CD_DEC
             nTrack := WrapWert ( (nEvent==CD_DEC),;
                                   nTrack, nFirstTrack, nLastTrack )
             // Position Head at Track
             PlayCd (nTrack, 1, 0)
             nEvent := CD_UPDATE

          // ----------
          // Stop Track
          // ----------
        CASE nEvent == CD_STOP
             StopCD()
             nEvent := CD_UPDATE


          // ----------
          // Play Track
          // ----------
        CASE nEvent == CD_PLAY

             // Play Track, if input is valid
             PlayCd (nTrack, 0, -1)

             // Next Task: Update Display
             nEvent := CD_UPDATE

          // -----------
          // Pause Track
          // -----------
        CASE nEvent == CD_PAUSE
             IIF( GetPauseCD(), ContinueCD(), PauseCD())
             nEvent := CD_UPDATE

        ENDCASE

     ENDDO
     MSE_Show (.f.)

     ScrRest ( oScreen )

  RETURN ( nil )
