
 /* COLORSET.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


  #include "SOUNDVIS.CH"
  #include "INKEY.CH"

  #define  F_WBLUE     31               // LiteWhite on Blue
  #define  F_NHB       48               // Black on LiteBlue
  #define  F_NW       112               // Black on White
  #define  F_RW       116               // Red on White
  #define  F_WBROWN   191               // LiteWhite on Brown (converted)
  #define  F_NBEIGE   208               // black on Beige     (converted)
  #define  F_RBEIGE   212               // red on Beige       (converted)



/*
    VgaMenu  () -> nil                                  
    Demo using WRAPWERT(), SETDAC(), A_RED(),           
    A_BLUE() and A_GREEN()                              
    With the help if these you can read and write       
    the Vga-Palette. It's also a good example of        
    'How to add a Mouse'                                
                                                        
  */
                                                
  FUNCTION VgaMenu ()

 // Coordinates
    LOCAL  nTRow := 7, nLCol := 1

 // Array for the 3 main colors
    LOCAL aColorCon := { a_Red(0), a_Green(0), a_Blue(0) }

 // Control and UpdateFlags
    LOCAL lNewCon := .f., lNewColorCon := .f., lNewDAC := .f.

 // WorkVars
    LOCAL nPalette := 0, nControl := 1
    LOCAL xTemp, nX, nKey, cScreen

 // MousePosition and first ControlRow
    LOCAL nMouseRow, nMouseCol, nConRow

 // declare ColorSave-Array
    LOCAL aOrgColor [ 16, 3], nOrgButt

 // turn of Cursor and Mouse
    LOCAL nCursor := SETCURSOR(0), lMouse := Mse_Show (.F.)

 // save original values
    FOR nX := 0 TO 15
        aOrgColor [nX+1] := { a_Red(nX), a_Green(nX), a_Blue(nX) }
    NEXT

 // Here comes the surrounding 'move-loop'
 // --------------------------------------
 DO WHILE nKey # K_ESC


    // build screen
    // --------------
    OPENWIN FROM nTRow, nLCol TO nTRow+11, nLCol+75  ;
            TITLE    'ColorSet'                      ;
            TYP      WIN_MESSAGE                     ;
            TOPCOLOR F_WBROWN                        ;
            WINCOLOR F_NBEIGE                        ;
            SAVE TO cScreen


    // Calculate first ControlRow
    nConRow := nTRow+4


    // draw ColorFields
    // -----------------
    FOR nX := 0 TO 15
        OutLine ( nTRow+2, nLCol+7+( nX*4 ), ' ', 1, (nX+1)*15 )

    NEXT


    // 1.Controller is activ (pushed)
    // --------------------------------------------
    OutLine ( nTRow+4, nLCol+2, 'R', 2)
    OutLine ( nTRow+6, nLCol+2, 'G', 1)
    OutLine ( nTRow+8, nLCol+2, 'B', 1)


    // draw field
    // ------------
    ShowStr ( 10, 3, 'Color:',, .t. )
    ShowStr ( 10, 44, 'F3',, .t. )
    ShowStr ( 10, 56, 'F4',, .t. )

    nOrgButt := SetPref (C_BUTTLOWER, 208 )
    OutLine ( nTRow+10, nLCol+47, 'Reset',     1, F_NW )
    OutLine ( nTRow+10, nLCol+59, 'Reset all', 1, F_NW )

    OutLine ( nTRow+10, nLCol+11, STR( nPalette, 3), 1, F_NW )
    OutLine ( nTRow+10, nLCol+18, SPACE(22), 1, 15 )

    SetPref (C_BUTTLOWER, nOrgButt )


    // ============
    // Input-Loop
    // ------------
    DO WHILE .t.



       // Draw Control-line and Values
       // -----------------------------
       FOR nX := 1 TO 3
           // Calculate Row
           xTemp := nTRow+2+( nX * 2)

           // Draw Control-line ( akctive Control-line light white)
           HLinie  ( xTemp, nLCol+6, nLCol+70,;
                          IIF ( nControl == nX, 240, F_NW), A_HORIZONT )

           ShowStr ( xTemp, nLCol+6+ aColorCon [nX], '')
           ShowStr ( xTemp, nLCol+71, STR( aColorCon [nX], 2) )

       NEXT

       // draw description
       // -----------------
       ShowStr ( 10, 12, STR( nPalette, 3),, .t.)
       ShowStr ( 10, 18, SPACE(24), nPalette * 16, .t. )
       
       // Wait for the user to do something
       // ----------------------------------
       Mse_Show (.t.)
       nKey := INKEY(0)
       Mse_Show (.f.)

       // =====================
       // get key
       // mousebutton pushed ?
       // ---------------------
       IF nKey == K_MOUSE

          // get Position
          nMouseRow := Mse_Row()
          nMouseCol := Mse_Col()


          DO CASE

          // Mouse on Icon ?
          // ---------------
          CASE ( nX := oMouseWin ()) # 0
               IF nX == M_CLOSE
                  nKey := K_ESC

                ELSEIF nX == M_MOVE
                   nTRow := IIF ( nTRow == 0, 7, 0)
                   nLCol := IIF ( nLCol == 0, 1, 0)
                   EXIT

                ENDIF


          // Mouse on ColorField ?
          // ----------------------
          CASE Mse_Check ( 2, 7,, 70, .t. )

               // on which one, please ?
               FOR nX := 1 TO 16

                   // I see.. get ColorValues
                   IF nMouseCol < nLCol+7+( nX * 4 )
                      nPalette := --nX
                      aColorCon := { a_red  ( nPalette ),;
                                    a_green( nPalette ),;
                                    a_blue (nPalette  ) }
                      EXIT
                   ENDIF
               NEXT


            // Maus on RED ?
            // --------------
          CASE Mse_Check ( 4, 6,, 69, .t. )
               nControl := 1
               lNewCon := lNewDAC := .t.
               aColorCon[ nControl ] := nMouseCol - (nLCol+6)


            // hum, maybe on GREEN ?
            // ---------------------
          CASE Mse_Check ( 6, 6,, 69, .t. )
               nControl := 2
               lNewCon := lNewDAC := .t.
               aColorCon[ nControl ] := nMouseCol - (nLCol+6)


            // or BLUE
            // --------
          CASE Mse_Check ( 8, 6,, 69, .t. )
               nControl := 3
               lNewCon := lNewDAC := .t.
               aColorCon[ nControl ] := nMouseCol - (nLCol+6)


            // Reset Color ?
            // -------------
          CASE Mse_Check ( 10, 47,, 51, .t. )
               nKey := K_F3


            // Reset all Colors ?
            // ------------------
          CASE Mse_Check ( 10, 59,, 66, .t. )
               nKey := K_F4

          ENDCASE
       ENDIF


       // Now for 'normal' KeyCodes
       // --------------------------
       DO CASE


         // Increase or Decrease ColorIntensity ?
         // --------------------------------------
       CASE nKey == K_LEFT .OR. nKey == K_RIGHT
            aColorCon[nControl] := ;
              WrapWert ( nKey == K_RIGHT, aColorCon[nControl], 0, 63 )
              lNewDAC := .t.


         // Beginning or End of Control-line ?
         // -----------------------------------
       CASE nKey == K_HOME .OR. nKey == K_END
            aColorCon[nControl] := IIF( nKey == K_HOME, 0, 63 )
            lNewDAC := .t.


         // Up or Down, change MainColor
         // -----------------------------
       CASE nKey == K_UP .OR. nKey == K_DOWN
            // get new ColorNo
            nControl := WrapWert( nKey == K_DOWN, nControl, 1, 3)
            lNewCon := .t.


         // Next Palette
         // -------------
       CASE nKey == K_PGDN .OR. nKey == K_PGUP
            nPalette := WrapWert( nKey == K_PGUP, nPalette, 0, 15)
            aColorCon := { a_red  (nPalette),;
                          a_green(nPalette),;
                          a_blue (nPalette)}


         // Restore all DAC-Registers
         // --------------------------
       CASE nKey == K_F4
            FOR nX := 1 TO 16
                SetDac ( nX-1, aOrgColor [ nX, 1],;
                               aOrgColor [ nX, 2],;
                               aOrgColor [ nX, 3] )
            NEXT

            lNewColorCon := .t.


            // Restore active DAC-Register
            // ----------------------------
       CASE nKey == K_F3
            lNewDAC := .t.
            aColorCon := { aOrgColor [ nPalette+1, 1],;
                          aOrgColor [ nPalette+1, 2],;
                          aOrgColor [ nPalette+1, 3] }

         // Done ?
         // -------
       CASE nKey == K_ESC
            EXIT


       ENDCASE



       // Set new ColorControl ?
       // =======================
       IF lNewCon

          // Flag reset
          lNewCon := .f.

          // deactivate old ColorControl
          OutFrame ( nConRow, nLCol+2, nConRow, nLCol+4, 1)

          // calculate new row
          nConRow := nTRow+2+( 2*nControl )

          // 'push' the right ColorButton
          OutFrame( nConRow, nLCol+2, nConRow, nLCol+4, 2)

       ENDIF


       // Read new ColorRegister ?
       // =========================
       IF lNewColorCon

          // Flag reset
          lNewColorCon := .f.

          // Read ColorRegister and save to array
          aColorCon := { a_red  (nPalette),;
                        a_green(nPalette),;
                        a_blue (nPalette)}
       ENDIF

       // DAC new ?
       // ==========
       IF lNewDAC
          lNewDAC := .f.
          SetDAC ( nPalette, aColorCon[1], aColorCon[2], aColorCon[3] )

       ENDIF


    ENDDO
    ScrRest (cScreen)

  ENDDO
  Mse_Show(lmouse)


  RETURN ( nil )

