 /*
     PROGRAMM ... :   Demo.prg
     AUTHOR ..... :   Tom Groeger
     TRANSLATION  :   Max Bressel
     DATE ....... :   09/26/93
     PURPOSE .... :   Sound & Vision demonstration

     compile CLIPPER DEMO.prg /m /n
     link    BLINKER FILE DEMO, CDPLAY, COLORSET, DIRBROWSE,
                      MEMORY, MIXER, TBROWSE, SYSINIT, 
                      ERRORSYS, GETSYS  LIB SoundVis


     ATTENTION!
     SetPref() only available in registered version !

  */


 // INCLUDES
 // --------
 #include 'INKEY.CH'
 #include 'SET.CH'
 #include "SOUNDVIS.CH"

 // color definition
 // ----------------
 #define  F_WBLUE     31               // light White on blue
 #define  F_NHB       48               // black on light blue
 #define  F_NW       112               // black on white
 #define  F_RW       116               // black on red
 #define  F_WBROWN   191               // light white on brown (transfered)
 #define  F_NBEIGE   208               // black on beige (transfered)
 #define  F_RBEIGE   212               // red on beige

 #define STD_INFO 'N/*RB,N/W,,,R/*RB'

 // menu definitions
 // -----------------
 #define M_POINTSTAT  12
 #define M_POINTLIST  13
 #define M_MEMORY     40
 #define M_VGASET     41
 #define M_SIGN       42
 #define M_SOUND      44
 #define M_FM         45
 #define M_SBINIT     46
 #define M_RECVOC     47
 #define M_CDROM      48
 #define M_MIXER      49
 #define M_HBUTTON    50
 #define M_VBUTTON    51
 #define M_LISTE      52
 #define M_CRC        53
 #define M_OUTLINE    54
 #define M_QUEST      55
 #define M_ALERT      56
 #define M_FILE       75
 #define M_HELP     200


 PROCEDURE Main

    // save DOS screen
    LOCAL cDosScreen := ScrSave(0,0,24,79)

    // break flag
    LOCAL lExit := .f.

    // codeblock for end or programm
    LOCAL bExit := {||lExit := .t.}

    // MouseArray, Pos 1,2 to 1,3 will end the program
    LOCAL aMouse  := {{1, 2, 3, bExit}}

    // WorkVars..
    LOCAL nKey, cCrc32, nX
    LOCAL c2Screen, cChr, nZeile, nSpalte

    LOCAL cMessage, aButton := {'~OK','watch ~again ??'}

    LOCAL xDummy1, xDummy2, xDummy3, xDummy4, aText, oScroll

    // presetting CheckPrompt
    LOCAL lSound := .t.

    // block for CheckPrompt, lSound PER REFERENCE!!
    LOCAL bSetSound := {|lModus|SetSound(@lSound, lModus)}

    // Important ! with our SysInit thre is no more PUBLIC Getlist !
    LOCAL GetList := {}

    //building the menu arrays
    // --------------------------

    LOCAL aDatei := { ;
     {'~Horizont. Buttons' , M_HBUTTON, .T. ,'Window with ButtonChoice'},;
     {'~Vertical  Buttons' , M_VBUTTON, .T. ,'Window with ButtonBar'},;
     {A_SEP},;
     {'~Listings-Demo'     , M_LISTE,   .T. ,'Browse with 3D effects and buttons.'},;
     {'~OutLine-Demo'      , M_OUTLINE, .T. ,'GETs with frames...'},;
     {'~CRC calculation'   , M_CRC,     .T. ,'CRC32-Checksum of a file'},;
     {A_SEP},;
     {'~Question-Box'      , M_QUEST,   .T. ,'any questions ?'},;
     {'~AlertBox'          , M_ALERT,   .T. ,"alarm.. hey what's going on..."},;
     {'~FileBox'           , M_FILE,    .T. ,'filebox, use your mouse '},;
     {A_SEP},;
     {'~End of Demo'       , B_QUIT,    .T. ,"...outta here ?!", 'ALT-F4' } }


    LOCAL aSubSubPt :={ ;
     {'~shoot him', 111, .T. , 'oh no, too loud'},;
     {'~hang him',  112, .T. , 'not loud enough'},;
     {'~drown him', 113, .T. , 'hmmm...too ~good for him'},;
     {'~slain him', 114, .T. , "yeah... ~that's it!"} }


    LOCAL aSubPoint :={ ;
     {'~add new Points',  101 , .T. ,'gee, another one ?'},;
     {'~change Points',   102 , .T. ,"are you sure ? :-)"},;
     {'~delete Point',    103 , .T. ,'hum...why did he leave ?'},;
     {A_SEP},;
     {'~get rid of Point ', aSubSubpt, .T.,'ultima ratio..',''} }


    LOCAL aPoint :={ ;
     {'~Fees',       M_POINTSTAT,.T.,'payments, ~contributions'},;
     {'~Pointlist',  M_POINTLIST,.F.,'list of all my points'},;
     {A_SEP},;
     {'~Database of points',aSubPoint,  .T.,'what will we do with them ?','' } }


    LOCAL aSystem :={ ;
     {'~Memory information' ,  M_MEMORY,  .T. ,'Sound & Vision leaves a lot of it..'},;
     {'C~olor change' ,        M_VGASET,  .T. ,'some Mimikri ?'},;
     {'~ASCII-characters' ,    M_SIGN,    .T. ,'wow...'},;
     {A_SEP},;
     {'Soundblaster ~Init',    M_SBINIT,  .T., 'Change Soundblasters defaults'},;
     {'Sound~blaster VOC' ,    M_SOUND,   .T., 'do you have one ?'},;
     {'S~oundblaster FM' ,     M_FM,      .T., 'At least an Adlib ?'},;
     {'Swith the Soun~d' ,   bSetSound,   .T., 'toggle Sound On/Off'},;
     {A_SEP},;
     {'~CD-Player',            M_CDROM,   .T., 'May the Sound be with you'},;
     {'Mi~xer',                M_MIXER,   .T., 'Waking up the neighbours..'} }



    LOCAL aMain :={ ;
     {'~Window'       , aDatei,  .T., 'Window and Button demo'},;
     {'~PopUps'       , aPoint,  .T., 'nested PopUp Menu'},;
     {'Sys & ~Sound'  , aSystem, .T., "let's boot your computer <g>"},;
     {'~Help'         , M_HELP,  .T., 'I think I can help', 36 } }


    // Settings
    // --------
    SET(_SET_CURSOR,0)
    SET(_SET_DECIMALS,2)
    SET(_SET_WRAP,.t.)
    SET(_SET_SCOREBOARD,.f.)
    SET(_SET_DELIMITERS,.f.)

    SETBLINK(.f.)

    // mask- and Menu color
    // ----------------------
    SetDAC (C_RB,25,17,23)              // magenta       will be brown/red
    SetDAC (C_RG, 41, 31, 24)           // brown         will be somewhat darker
    SetDAC (C_HW,55,55,55)              // light white   will be somewhat lighter
    SetDac (C_HBG, 34, 18, 26)          // light blue    will be red-brown
    SetDac (C_HRB, 42, 41, 36)          // light magenta will be pus-yellow
    SetDac (C_HRG, 63, 54, 21)          // Yellow a little darker


 // here we go ...
 // --------------
    PlayVoc ( 'hal.voc')


    SETCOLOR('RG+/RG')                 // background
    CLS

    SetPref ( C_POPCOL,    240 )       // windows/text black on white
    SetPref ( C_POPKEY,    244 )       // Hotkeys red on light blue
    SetPref ( C_POPPASSIV, 248 )       // non chooseable point, grey on white
    SetPref ( C_POPSHORT,  244 )       // ShortCut blue on light white

    SetPref ( C_BOXHEADER,  31 )       // heading of the Alertboxes

    SetPref ( C_DESCROW,    22 )       // row for description
    SetPref ( C_DESCCOL,     5 )       // column for descripton
    SetPref ( C_DESCEND,    75 )       // endcolumn
    SetPref ( C_GRAFBUTTON,  1 )       // graphic button


    // set mouse on position 13,39 and show
    //---------------------------------------
    Mse_Set ( 13,39, .f.)



    // does the nice window
    // ---------------------
    OPENWIN  FROM 1,2 TO 23,77                ;
             TITLE 'SOUND & VISION demonstration' ;
             TYP WIN_FULL


    // color for inside window
    // ------------------------
    ColorMe ( 4, 4, 20, 73, 94)
    
    SETKEY(K_ALT_F4, bExit)           // ALT-F4 ends the demo
    SETKEY(K_F2, {||SbMixer()})       // Just in case...


    // PROGRAM
    // -------

    DO WHILE nKey # B_QUIT

       // call menu
       nKey := BarMen (2,4,1,,aMain, aMouse)




       DO CASE

         // ========================
         // horizontal ButtonDemo
         // ========================
       CASE nKey == M_HBUTTON


            DO WHILE .t.
               nKey := AlertBox(2,'DEMO.EXE Vers. 1.4   1993 Tom Groeger;'+;
                                 'choose via cursor, mouse;'+;
                                 'or character', aButton)

               IF nKey = M_CLOSE
                  Describe('CloseIcon')

               ELSEIF nKey = M_MOVE
                  Describe('MoveIcon')

               ELSEIF nKey = M_CHOICE
                  Describe('ChoiceIcon')

               ENDIF

               IF nKey == 1 .OR. nKey == K_ESC
                  Exit
               ENDIF

            ENDDO


         // ======================
         // Vertical ButtonDemo
         // ======================
       CASE nKey == M_VBUTTON

            OPENWIN FROM 6,25 TO 18,55        ;
                    TITLE 'vertical button  ' ;
                    TOPCOLOR F_WBROWN         ;
                    WINCOLOR F_NBEIGE         ;
                    TYP   WIN_MESSAGE         ;
                    SAVE TO c2Screen

            ShowStr ( 11, 27, 'which drive')
            ShowStr ( 12, 27, 'should be')
            ShowStr ( 13, 27, 'formatted?')

            xDummy1 := 3
            @ 8,46 GET xDummy1 AS PUSHBUTTON                         ;
                       {' ~A: ',' ~B: ',' ~C: ',' ~D: ','~Exit'}     ;
                       COLOR F_NW  HOTKEY F_RW                       ;
                          VERTIKAL

            READ
            ScrRest ( c2Screen )


         // ==================
         // list-browsing demo
         // ==================
       CASE nKey == M_LISTE


         // make TestArray
            aText := {'Al Bundy          452324       1022.50',;
                      'Mr.Fabulous     2 -55721        561.80',;
                      'Billy Wilder     23/4530      51022.00',;
                      'El Diabolo         i-448         45.60',;
                      'Luciano Pavarotti 275679        532.10',;
                      'Margret Thatcher   75424      32423.67',;
                      'Toni Curtis      2435654         34.50',;
                      'Stan Laurel          345       4522.20',;
                      'Mark Lussier       32527        911.20',;
                      'Bruce Wayne       1-3/93       1723.20' }



         // Window
         // --------------
            OPENWIN FROM 2,10 TO 22,68  ;
                    TITLE 'Hall of Fame';
                    TOPCOLOR F_WBROWN   ;
                    WINCOLOR F_NBEIGE   ;
                    TYP WIN_LIST        ;
                    SAVE TO c2Screen

         // create ScrollBar
            oScroll  := ScrollNew (  3, 67, 21, .f., 1 )
            oHScroll := ScrollNew ( 22, 10, 65, .t., 12 )


         // Frame ListArea
            OutFrame ( 6, 12, 15, 64, 2)


         // with SetPref ( C_BUTTLOWER, 208 ) the outline-boarder
         // would be drawn as a double line (asc208)

            xDummy1 := SetPref( C_BUTTLOWER, 208 )

            OutLine ( 4, 15, 'GOODS',       1, F_NW , .t.)
            OutLine ( 4, 34, 'INVOICE No.', 1, F_NW )
            OutLine ( 4, 52, 'AMOUNT',      1, F_NW )

            SetPref ( C_BUTTLOWER, xDummy1 )

            ShowStr( 21, 14, 'Sum of Invoices')

         // redirect ScrollKeys
            SETKEY(K_DOWN, {||ScrollIt ( K_DOWN, aText, @oScroll)})
            SETKEY(K_UP,   {||ScrollIt ( K_UP,   aText, @oScroll)})
            SETKEY(K_HOME, {||ScrollIt ( K_HOME, aText, @oScroll)})
            SETKEY(K_END,  {||ScrollIt ( K_END,  aText, @oScroll )})


         // Draw Buttons and choose
         // -----------------------
         nChoice := K_HOME

         DO WHILE nChoice # 0 .AND. nChoice # 4 .AND. nChoice # K_ESC

            oScroll := ScrollIt ( nChoice, aText, oScroll )
            nChoice := 1

            @ 18, 13 GET nChoice                                      ;
                     AS PUSHBUTTON                                    ;
                     { '~book','~print','~delete','~abort' }         ;
                     COLOR F_NW                                       ;
                     HOTKEY F_RW

             READ

             DO CASE

             // test horizontal ScrollBar
             CASE nChoice == M_LEFT
                  oHScroll := ScrollPos ( oHScroll,;
                                        GetScrollPos ( oHScroll )-1)

             CASE nChoice == M_RIGHT
                  oHScroll := ScrollPos ( oHScroll,;
                                        GetScrollPos ( oHScroll )+1)

             // test ListBox
             CASE nChoice == 1
                  ChoseBox ( 4, 25, 10,, aText )

             ENDCASE

         ENDDO


         // release KeyTraps
         // -----------------------
            SETKEY(K_DOWN, NIL )
            SETKEY(K_UP,   NIL )
            SETKEY(K_HOME, NIL )
            SETKEY(K_END,  NIL )


         // restaore Screen
            ScrRest ( c2Screen )



         // ==============
         // OutLine - Demo
         // ==============
       CASE nKey == M_OUTLINE

            // a few dummies
            xDummy1 := 'Focke Wulff' 
            xDummy2 := '190-D9  '
            xDummy3 := CTOD('12.10.44')
            xDummy4 := 1250
            nX := 1 
            nY := 1

            OPENWIN from 6,12 to 19,63 title 'WarBirds'  ;
                    topcolor F_WBROWN  wincolor F_NBEIGE ;
                    typ WIN_MESSAGE                      ;
                    save to c2Screen

            SETCOLOR  ( STD_INFO )

            @  8, 16 SAY 'Manufact.'
            @ 10, 16 SAY 'Version'
            @ 12, 16 SAY 'First fly'
            @ 14, 16 SAY 'Total'

         // read as 'framed GET'
         // --------------------------------
            @  8, 30 GET xDummy1 AS FRAME IN F_NW,F_NBEIGE ;
                                 LISTBOX  { 'Focke Wulff',    ;
                                            'Messerschm.', ;
                                            'Arado',         ;
                                            'Heinkel',       ;
                                            'Junkers '}
            @ 10, 33 GET xDummy2 AS FRAME IN F_NW,F_NBEIGE
            @ 12, 33 GET xDummy3 AS FRAME IN F_NW,F_NBEIGE
            @ 14, 32 GET xDummy4 AS FRAME IN F_NW,F_NBEIGE PICT '999999.99'
            @ 17, 16 GET nX AS PUSHBUTTON   ;
                         {' ~StealIt ',' ~BuyIt  ',' ~ForgetIt ' }  ;
                         COLOR F_NW  HOTKEY F_RW
            @ 08, 48 GET nY AS PUSHBUTTON             ;
                         {' ~Fighter',' ~Bomber ' }   ;
                         COLOR F_NW  HOTKEY F_RW      ;
                         VERTIKAL
            READ

            ScrRest ( c2Screen )

          // ===========
          //  Crc-Demo
          // ===========
       CASE nKey == M_CRC
            xDummy1 := DirManager ('','*.*')

            IF LEN(xDummy1) > 0

               c2Screen := OpenMask (  8, 10, 16, 70,;
                                   'CRC-Check', 51, F_WBROWN, F_NBEIGE)

               SETCOLOR( 'N/*RB,N/W,,,R/*RB' )

            // switch mouse cursor to a sandglass
               Mse_Wait ( .t. )
               Mse_Set ( 14, 45, .t.)

            // calculate Crc-Sum
               xDummy2 := GetCrc32 ( xDummy1 )

            // Reset Mouse
               Mse_Wait (.f.)
               Mse_Show(.f.)

            // Show CRC
               ShowStr ( 12, 17, SPACE( 52) )
               ShowStr ( 11, 17, 'CRC-Sum of '+ xDummy1 +' is', F_NBEIGE)
               ShowStr ( 12, 35, xDummy2 , 222 )

               // Ok ?
               xDummy := 1
               @ 14, 34 GET xDummy AS PUSHBUTTON {'  ~OK  '}  ;
                        COLOR F_NW  HOTKEY F_RW               ;
                        TIMEOUT 5

               READ

              ScrRest ( c2Screen )

            ENDIF


          // =============
          //  QuestionBox
          // =============
       CASE nKey == M_QUEST
            xDummy1 := SetPref( C_BOXHEADER, F_NW )

            AlertBox(0,'Are you going to registrate for;'+;
                                  '      SOUND & VISION ?',;
                        {'~Sure,', "~I'll do it", '~tomorrow...'})

            SetPref( C_BOXHEADER, xDummy1 )


          // ==========
          //  Alert Box
          // ==========
       CASE nKey == M_ALERT
            xDummy1 := SetPref( C_BOXHEADER, F_NW )

            AlertBox(1,'do you really want to format ;'+;
                                  'drive C: ?',;
                        {'~Yeah, sure', 'oh no, better ~not'})

            SetPref( C_BOXHEADER, xDummy1 )



          // ======
          //  FEES
          // ======
       CASE nKey == M_POINTSTAT

            OPENWIN FROM 06, 20 TO 21, 60 ;
                   TITLE "Cheaper than you'd think....." ;
                   TOPCOLOR F_WBROWN   ;
                   WINCOLOR F_NBEIGE   ;
                   TYP WIN_MESSAGE     ;
                   SAVE TO c2Screen

            ShowStr ( 08, 26, 'Copyright  Tom Groeger 1993', 212 )
            ShowStr ( 10, 32, 'Distributed by:')
            ShowStr ( 11, 33, 'SOFTSOL GmbH', 212 )
            ShowStr ( 12, 31, 'Neue Strasse 35a')
            ShowStr ( 13, 29, '21073 HAMBURG/Germany')
            ShowStr ( 14, 30, 'Tel:+49-40-7661290')
            ShowStr ( 15, 30, 'Fax:+49-40-7665664')
            ShowStr ( 16, 30, 'BBS:+49-40-7665527')
            ShowStr ( 17, 30, 'CIS:   100112,3401')

            xDummy := 1
            @ 19, 34 GET xDummy AS PUSHBUTTON {'  ~OK  '}  ;
                     COLOR F_NW  HOTKEY F_RW               ;
                     TIMEOUT 20
            READ

            ScrRest ( c2Screen )

          // =============
          //  SOUNDBLASTER
          // =============
       CASE nKey == M_FM

            aPiano  := {  1,   17,  77,  0, 241, 210, 96, 123, 00, 00, 08 }
            aString := { 113, 161, 139, 64, 113,  66, 17,  21, 00, 00, 06 }


            FM_Instr (1, aPiano)
            FM_Instr (2, aPiano )
            FM_Instr (3, aString )
            FM_Instr (4, aString )

            nx = 1
            do while nx < 13

               FM_KeyOn ( 1, nx , 2)
               FM_KeyOn ( 2, nx , 4)
               FM_KeyOn ( 3, 13-nx  , 2 )
               FM_KeyOn ( 4, 13-nx++, 4 )

               FM_Delay (9)

            enddo
            FM_KeyOff ( 1 )
            FM_KeyOff ( 2 )
            FM_KeyOff ( 3 )
            FM_KeyOff ( 4 )


         // Play VOC-FILE
         // -------------
       CASE nKey == M_SOUND
            xTemp1 := DirManager ('','*.voc')

            IF LEN(xTemp1) > 0
               PlayVoc ( xTemp1 )
            ENDIF



       CASE nKey == M_SBINIT
         // Soundblaster Init

            xDummy1 := 7
            xDummy2 := 220
            xDummy3 := 1

            PlayStop()

            OPENWIN from 9,22 to 19,55 title 'Soundblaster'  ;
                    topcolor F_WBROWN  wincolor F_NBEIGE ;
                    typ WIN_MESSAGE                      ;
                    save to c2Screen

            SETCOLOR  ( STD_INFO )
            SETCURSOR ( 1 )

            @ 12, 26 SAY 'IRQ-Number'
            @ 14, 26 SAY 'Portadress'
            @ 16, 26 SAY 'DMA-Chann.'
            DO WHILE .t.

               @ 12, 41 GET xDummy1 AS FRAME IN F_NW,F_NBEIGE PICT '99'
               @ 14, 40 GET xDummy2 AS FRAME IN F_NW,F_NBEIGE PICT '999'
               @ 16, 42 GET xDummy3 AS FRAME IN F_NW,F_NBEIGE PICT '9'

               READ

               IF ! SbInit ( xDummy1, xDummy2, xDummy3 )
                  IF AlertBox (1,;
                     'Something is going wrong ... ;'+;
                     'Valid Input is IRQ 2/5/7/10, Port 220/240/260;'+;
                     'and DMA-Ch. 0, 1, 3 with a SbPro',;
                      { '~Retry ', '~Cancel ' } ) == 2
                     EXIT
                  ENDIF

               ELSE
                  EXIT

               ENDIF

            ENDDO
            SETCURSOR ( 0 )
            ScrRest ( c2Screen )


          // =============
          //  File-Manager
          // =============
       CASE nKey == M_FILE
            Dirmanager('','*.*')


          // ============
          //  CD-ROM
          // ============
       CASE nKey == M_CDROM
            CdPlayer()

          // ============
          //  MIXER
          // ============
       CASE nKey == M_MIXER
            SbMixer()

          // ================
          // character table
          // ================
       CASE nKey == M_SIGN
            nX := 1
            xDummy1 := ScrSave(4,4,20,73)

            FOR nRow := 1 TO 15
                FOR nColumn := 1 TO 51 STEP 3
                    IF nX >= 213 .AND. nX <= 217
                       nX++
                    ELSE
                       ShowStr (nRow+4, nColumn+14, CHR( nX++))
                    ENDIF
                NEXT
            NEXT

            MSE_Show (.t.)
            INKEY(0)
            MSE_Show (.f.)

            ScrRest ( xDummy1 )


          // ============
          //  SystemInfo
          // ============
       CASE nKey == M_MEMORY
            ShowMem()


          // ==============
          //  Change colors
          // ==============
       CASE nKey == M_VGASET
            VgaMenu()

       CASE nKey == M_HELP

            ShowStr(12,35,'RTFM !')
            INKEY(1)
            ShowStr(12,35,'      ')


          // ===============
          //  Finito l'amore
          // ===============
       CASE nKey == B_ESC .OR. lExit

            // Now we want show our impressions on SOUND & VISION <g>
            PlayVoc("Cheer.voc")


            nKey := 'Y'
            SETCURSOR(1)
            Describe ('Programm ~abort ? ')

            SETCOLOR(',N/*W')
            @ 22,27 Get nKey PICT '!'
            READ

            IF 'Y' $ nKey
               nKey := B_QUIT
            ELSE
              nKey := 0
              lExit := .f.

            ENDIF

            SETCURSOR(0)


       ENDCASE

    ENDDO


 // turn mouse off
 // ---------------
    Mse_Show(.f.)
    Mse_Exit()

 // Switch off the Radio
 // --------------------
    PlayStop()

 // restoring
 // -----------
    SETCOLOR('W/N')
    ScrRest(cDosScreen)
    @ 23,0 SAY 'Thanks for trying SOUND & VISION'

 // byebye
 // -------
    QUIT




/**************************************************
 *
 *   FUNCTION ScrollIt( nKey, aText, oScroll ) -> oScroll
 *    
 *   Demo of a function called via SetKey.
 *   This function is passed via CodeBlock and scrolls the data
 *   in a BrowseWindow up and down.
 *   Function is called via SETKEY or by the GET AS A PUSHBUTTON
 *   PARAMETER :  nGrab  : key pressed
 *                aText  : Array containing test-data
 *                oScroll: ScrollBarObject
 */
 FUNCTION ScrollIt ( nKey, aText, oScroll )

    LOCAL nX, nIndex
    LOCAL nMaxLen := LEN ( aText )
    LOCAL nTop := GetScrollTop(oScroll)
    LOCAL nBot := GetScrollEnd(oScroll)
    LOCAL nPos := GetScrollPos(oScroll)



    DO CASE
    CASE nKey == K_UP  .OR. nKey == M_UP
         oScroll := ScrollPos ( oScroll, --nPos )

    CASE nKey == K_DOWN .OR. nKey == M_DOWN 
         oScroll := ScrollPos ( oScroll, ++nPos )

    CASE nKey == K_HOME
         oScroll := ScrollTop(oScroll)

    CASE nKey == K_END
         oScroll := ScrollBottom(oScroll)


    ENDCASE


    // Show Array
    // --------------
    FOR nX := 1 TO nMaxLen

        // Change row-colors White/Lightblue
        ColorMe ( nX+5, 12, nX+5, 64, IIF (nX % 2 == 0, F_NHB, F_NW ))

        // show ArrayPosition
        ShowStr ( nX+5, 17, aText [nX])


    NEXT

    nPos := GetScrollPos ( oScroll )+2
    c_ColMen( MIN( MAX(nPos, nTop+3),nTop+12), 12, 64, 2)


 RETURN ( oScroll )



**************************************************
*
*   FUNCTION SetSound( lSound , lMode ) -> lSound
*
*   Demonstrates a function called via CheckPrompt.
*   This function is passed via CodeBlock, it inverts
*   VAR lSound, which is also passed via the CodeBlock
*   (PER REFERENCE). Returns the new value.
*
*   PARAMETER :  lSound  is a logVar for Sound on/off
*                lMode   .F.= read only lSound and return it
*                        .T.= invert lSound and return it
*

 FUNCTION SetSound( lSound , lMode )

    IF lMode
       lSound := ! lSound

       // check if you're already playing a VOC-File and turn it off
       IF ! lSound
          PlayStop ()
       ENDIF

    ENDIF

 RETURN (lSound)


