
 /* DIRBOWSE.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


 #include "SOUNDVIS.CH"
 #include "INKEY.CH"


 #define  DIR_EXIT    -5
 #define  DIR_INFILE  -6
 #define  DIR_INDIR   -7
 #define  DIR_INMASK  -8
 #define  DIR_INPATH  -9

 #define  DIR_MASK    1
 #define  DIR_LOAD    2
 #define  DIR_SHOW    3
 #define  DIR_NEWPATH 8
 #define  DIR_BUTTON  9

 #define  F_NAME      1

 #define  F_WBLUE     31               // LiteWhite on Blue
 #define  F_NHB       48               // Black on LiteBlue
 #define  F_NW       112               // Black on White
 #define  F_RW       116               // Red on White
 #define  F_WBROWN   191               // LiteWhite on Brown (converted)
 #define  F_NBEIGE   208               // black on Beige     (converted)
 #define  F_RBEIGE   212               // red on Beige       (converted)



/*
    DIRMANAGER ( cMaske ) -> cFileName                  
    Ready-to-use Window's - like Filemanager            
    with Mousesupport. Uses lot's of Sound&Vision       
    stuff ...                                           
                                                        
  */

  FUNCTION DirManager ( cPath, cFile )

  LOCAL nTRow := 4, nLCol := 10, nBRow := 20, nRCol := 66

  LOCAL nListRow := nTRow+5

  LOCAL nFileCol := nLCol+3

  LOCAL nDirCol := nLCol+23

  LOCAL aFile  := {}, aDir := {}, nFiles, nDirs

  LOCAL aBut := { '  ~OK  ','~Retry ','~Cancel' }

  LOCAL sBinObj := oAddButt ( nListRow, nDirCol+20, 112, 116, aBut, .t. )

  LOCAL nX, oScreen, cTemp, cFileName := ''

  LOCAL cOldColor := SETCOLOR ( 'N/W,+W/N')

  LOCAL nEvent := DIR_MASK

  LOCAL lMouseStat := Mse_Show ( .f.)

  LOCAL Getlist := {}

  LOCAL aMse := { ;
         { nListRow ,        0, nBRow-2,           0,          0 },;
         { nTRow+3, nFileCol+2, nTrow+3, nFileCol+14, DIR_INMASK },;
         { nTRow+3, nDirCol +2, nTrow+3, nDirCol +28, DIR_INPATH },;
         { nTRow+9, nDirCol+21, nTRow+9, nDirCol +29, DIR_EXIT   }}

   // Allow to leave Get
   ReadExit ( .t.)


   DO WHILE nEvent != DIR_EXIT

      DO CASE

        // Build Screen
        // ============
      CASE nEvent == DIR_MASK

           OPENWIN FROM nTRow, nLCol TO nBrow, nRCol ;
                   TITLE 'Directory Manager'         ;
                   TOPCOLOR 31                       ;
                   WINCOLOR 208                      ;
                   TYP   WIN_MESSAGE                 ;
                   SAVE  TO oScreen


        // Show Text
           ShowStr ( 2,  5, 'Filename:',      F_NBEIGE , .t.)
           ShowStr ( 2, 25, 'Directories:'  , F_NBEIGE , .t.)

        // Display Buttons
           oDisButt ( sBinObj )

        // Next Stop at ..
           nEvent := DIR_LOAD


         // Load Directories
         // ================
      CASE nEvent == DIR_LOAD


        // Get Path
           cPath := IIF( cPath == '', '\'+CURDIR()+'\', cPath )

        // Get Mask
           cFile := IIF( cFile == '', '*.*', cFile )


        // Read Directorys and Files
        // -------------------------
           aFile := {}
           aDir  := {}

           AEVAL ( DIRECTORY ( cPath-'*.', "D"),;
                      {|aDatei| AADD ( aDir, PADR(aDatei [F_NAME],12))})

           AEVAL( DIRECTORY ( cPath-cFile ),;
                     {|aDatei| AADD ( aFile, PADR(aDatei [F_NAME],12))})

           nFiles := LEN( aFile )
           nDirs  := LEN( aDir  )


           IF nFiles + nDirs == 0
              cPath := '\'
              nEvent := DIR_INPATH

           ELSE
              nEvent := DIR_SHOW

           ENDIF

           ShowStr ( 3,  5, PADR(cFile, 12), 212, .t. )
           ShowStr ( 3, 25, PADR(cPath, 30), 212, .t. )


        // Show Dir- and Filebox
        // ---------------------
      CASE nEvent == DIR_SHOW

           aListBox ( nListRow, nFileCol, nBRow-2, nFileCol+15, 112, 3)
           aListBox ( nListRow, nDirCol , nBRow-2, nDirCol+15 , 112, 3)

           FOR nX := 1 TO 10
               nY := nX+4

               IF nX <= nFiles
                  ShowStr ( nY, 4, aFile [nX],, .t.)
               ENDIF

               IF nX <= nDirs
                  ShowStr ( nY,  24 , aDir [nX],, .t. )
               ENDIF

           NEXT

           // What's next ?
           DO CASE
           CASE nFiles == 0
                nEvent := DIR_INDIR

           CASE nDirs == 0
                nEvent := DIR_INFILE

           CASE aMse[1, MSE_RET] == DIR_INFILE
                nEvent := DIR_INDIR

           OTHERWISE
                nEvent := DIR_INFILE

           ENDCASE


        // Activate File-Box
        // =================
      CASE nEvent == DIR_INFILE

           IF nFiles == 0
              nEvent := DIR_INMASK

           ELSE

              // set MouseArray [1] to DIR_INDIR
             aMse [1, MSE_LCOL] := nDirCol
             aMse [1, MSE_RCOL] := nDirCol+13
             aMse [1, MSE_RET ] := DIR_INDIR

             // Files 'TBrowsen'
             nSelect := memBrowse( nListRow, nFileCol, ;
                                   nBRow-2, nFileCol+14, aFile, aMse )

             // found any Files ?
             DO CASE
             CASE nSelect  > 0
                  ShowStr ( 3, 5, aFile[nSelect], 12, .t. )
                  nEvent := DIR_BUTTON

             CASE nSelect == B_RIGHT
                  nEvent :=  DIR_INDIR

             CASE nSelect == B_LEFT
                  nEvent :=  DIR_INMASK

             CASE nSelect == B_ESC
                  nEvent  := DIR_EXIT

                // MouseReturn
             OTHERWISE
                  nEvent :=  nSelect

             ENDCASE

           ENDIF

        // Activate Dir-Box
        // ================
      CASE nEvent == DIR_INDIR

           IF nDirs == 0
              nEvent := DIR_INPATH

           ELSE

             // set MouseArray to DIR_INFILE
             aMse [1, MSE_LCOL] := nFileCol
             aMse [1, MSE_RCOL] := nFileCol+13
             aMse [1, MSE_RET ] := DIR_INFILE

             nSelect := memBrowse( nListRow, nDirCol, ;
                                   nBRow-2, nDirCol+14, aDir , aMse )

             DO CASE
             CASE nSelect  > 0
                  nEvent := DIR_NEWPATH

             CASE nSelect == B_LEFT
                  nEvent :=  DIR_INFILE

             CASE nSelect == B_RIGHT
                  nEvent :=  DIR_INPATH

             CASE nSelect == B_ESC
                  nEvent  := DIR_EXIT

                // MouseReturn
             OTHERWISE
                  nEvent :=  nSelect

             ENDCASE


           ENDIF


        // Rework new Path
        // ===============
      CASE nEvent == DIR_NEWPATH

           cPath := TRIM( cPath )

           DO CASE
           CASE LEFT( aDir[nSelect], 2 ) == '. '
                nEvent := DIR_SHOW

           CASE LEFT( aDir[nSelect], 2 ) == '..'
                cPath  := LEFT( cPath, LEN( cPath)-1 )
                cPath  := LEFT( cPath, RAT( '\', cPath))

                nEvent := DIR_LOAD

           OTHERWISE
                cPath  := cPath-aDir[nSelect]-'\'
                nEvent := DIR_LOAD

           ENDCASE


        // Input new Path
        // ==============
      CASE nEvent == DIR_INPATH
           cPath := PADR( cPath, 28 )

           SETCURSOR (1)
           @ nTRow+3, nDirCol+2 GET cPath

           READ
           SETCURSOR (0)

           cPath := TRIM( cPath )
           IF RIGHT( TRIM(cPath), 1) != '\'
              cPath := cPath-'\'
           ENDIF

           nEvent := DIR_LOAD


        // Input new FileMask
        // ==================
      CASE nEvent == DIR_INMASK
           cFile :=  PADR( cFile, 12 )

           SETCURSOR (1)
           @ nTRow+3, nFileCol+2 GET cFile  VALID AT('.', cFile) != 0
           READ
           SETCURSOR (0)

           cFile := TRIM ( cFile )
           nEvent := DIR_LOAD


        // Get final OK
        // ============
      CASE nEvent == DIR_BUTTON
           nX := 1
           @ nListRow, nDirCol+20 GET nX             ;
                                  AS PUSHBUTTON aBut ;
                                  COLOR  112         ;
                                  HOTKEY 116         ;
                                  VERTIKAL
           READ

           DO CASE
           CASE nX == 1
                cFileName := cPath-TRIM(aFile[nSelect])
                nEvent := DIR_EXIT

           CASE nX == 2
                nEvent := DIR_LOAD

           OTHERWISE
                nEvent := DIR_EXIT

           ENDCASE


      ENDCASE



   ENDDO

   ScrRest ( oScreen  )
   SETCOLOR( cOldColor )

   MSE_Show( lMouseStat )

 RETURN( TRIM(cFileName))


