
 /* MIXER.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


  #include "SOUNDVIS.CH"
  #include 'INKEY.CH'


  #define  F_WBLUE     31               // LiteWhite on Blue
  #define  F_NHB       48               // Black on LiteBlue
  #define  F_NW       112               // Black on White
  #define  F_RW       116               // Red on White
  #define  F_WBROWN   191               // LiteWhite on Brown (converted)
  #define  F_NBEIGE   208               // black on Beige     (converted)
  #define  F_RBEIGE   212               // red on Beige       (converted)

  #define EVENT_EXIT   0
  #define EVENT_UPDATE 1
  #define EVENT_INKEY  2

  // Number of Channels
  #define CH_LEN       6

  #define STD_INFO 'N/*RB,N/W,,,R/*RB'


/*
    SbMixer () -> nil                                   
    If you own a Soundblaster PRO you can use it's      
    Mixer and control the Master/Voc/Fm/Cd/Line and     
    Microphon Volume with this handy function.          
                                                        
    It also shows the usage of GETSBVOL() and           
    SETSBVOL().                                         
                                                        
  */


  FUNCTION SbMixer ()

     LOCAL cScreen, nX, nY, nKey, Getlist := {}

     LOCAL nKanal := CH_MASTER

     LOCAL nEvent := EVENT_UPDATE

     LOCAL aLScroll, aRScroll, aVolume [2]

     LOCAL nFocus := 3

     LOCAL aSource := {'Master','Voice ','FM    ', ;
                       'CD    ','Line  ','Mikro ' }


     OPENWIN from 1,25 to 22,48 title 'SBPRO-Mixer'  ;
             topcolor 47 wincolor F_NBEIGE          ;
             typ WIN_MESSAGE                         ;
             save to cScreen

     SETCOLOR  ( STD_INFO )


     aLScroll := ScrollNew ( 4, 27, 20, .f., 0)
     aRScroll := ScrollNew ( 4, 31, 20, .f., 0)

     /* Show Scala and Description
        -------------------------- */
     FOR nX := 1 TO 15
         Hlinie ( 20 - nX, 29, 31)
     NEXT

     ShowStr ( 3, 36, 'Channel' )


     /* Mainloop
        ======== */
     DO WHILE nEvent # EVENT_EXIT

        DO CASE

        CASE nEvent == EVENT_UPDATE

             /* Read Mixer Registers  */
             aVolume  := GetSbVol ( nKanal )

             /* Set Scrollthump */
             ScrollPos ( aLScroll, 20 - aVolume[1] )
             ScrollPos ( aRScroll, 20 - aVolume[2] )

             /* Show active Channel */
             FOR nX := 1 TO CH_LEN
                 OutLine ( 2+ (nX*3), 36,;
                    aSource [nX], IIF ( nKanal+1 == nX, 2,1), F_NW )
             NEXT

             ShowStr ( 3, 27, 'L', IIF ( nFocus == 1 .OR. nFocus == 3,;
                                   F_RBEIGE, F_NBEIGE ))
             ShowStr ( 3, 31, 'R', IIF ( nFocus == 2 .OR. nFocus == 3,;
                                   F_RBEIGE, F_NBEIGE ))

             nEvent := EVENT_INKEY



        CASE nEvent == EVENT_INKEY
             Mse_Show (.t.)
             nKey := INKEY( 0 )
             Mse_Show (.f.)

             nEvent := EVENT_UPDATE


              /* Mousy? */
             IF nKey == K_MOUSE

                 /* Mouse on left or right Slider ?
                    ------------------------------- */
                IF ( nX := MAX ( ScrollMse ( aLScroll),;
                                 ScrollMse ( aRScroll) ) ) # 0

                    /* Left or right channel ? */
                   nFocus := IIF( ScrollMse ( aLScroll ) == 0, 2, 1)

                   DO CASE
                    /* Top Icon */
                   CASE nX == M_UP
                     nKey := K_UP

                    /* BottomIcon */
                   CASE nX == M_DOWN
                     nKey := K_DOWN

                    /* Hit Runway */
                   OTHERWISE

                      /* calc and set Value */
                     aVolume [nFocus] := 16-nX
                     SetSbVol( nKanal, aVolume)

                   ENDCASE

                 /* Maybe WindowIcon ?
                    ------------------- */
                ELSEIF ( nX := oMouseWin()) # M_NOMATCH

                    /* Get out of here ? */
                   IF nX == M_CLOSE
                      nEvent := EVENT_EXIT

                   ENDIF

                   /* Maybe you want to Resize or Reposition
                      the Window ? just ask for M_MOVE or M_CHOICE
                      and go ahead ! */

                 /* Switch to a new Channel ?
                    ------------------------- */
                ELSE

                   /* But which ? */
                  FOR nX := 1 TO CH_LEN
                    IF Mse_Check ( 2 + ( nX * 3 ), 36,,41 )
                       nKanal := nX-1
                       EXIT
                    ENDIF
                  NEXT

                ENDIF

             ENDIF


             /* Mouse is done, look for Key's
                ============================= */
             DO CASE

              /* Previous Channel
                 ---------------- */
             CASE nKey == K_PGUP
                  nKanal := WrapWert ( .f., nKanal, 0, 5 )


              /* Next Channel
                 ------------ */
             CASE nKey == K_PGDN
                  nKanal := WrapWert ( .t., nKanal, 0, 5 )


              /* Channel L-R-BOTH
                 ---------------- */
             CASE nKey == K_LEFT .OR. nKey == K_RIGHT
                  nFocus := WrapWert ( nKey == K_RIGHT, nFocus, 1, 3)


             CASE nKey == K_HOME .OR. nKey == K_END
                  IF nFocus == 1 .OR. nFocus == 3
                     aVolume[1] := IIF (nKey == K_HOME, 15, 1)
                  ENDIF
                  IF nFocus == 2 .OR. nFocus == 3   
                     aVolume[2] := IIF (nKey == K_HOME, 15, 1)

                  ENDIF
                  SetSbVol ( nKanal, aVolume )


              /* Increase / Decrease Volume
                 -------------------------- */
             CASE nKey == K_UP .OR. nKey == K_DOWN

                  /* Left or both Channels */
                  IF nFocus == 1 .OR. nFocus == 3
                     aVolume[1] := IIF ( nKey == K_UP,;
                                         MIN ( 15, aVolume [1]+2),;
                                         MAX (  1, aVolume [1]-2))
                  ENDIF


                  /* Right or both Channels */
                  IF nFocus == 2 .OR. nFocus == 3
                     aVolume [2] := IIF ( nKey == K_UP,;
                                          MIN ( 15, aVolume [2]+2),;
                                          MAX (  1, aVolume [2]-2))
                  ENDIF

                  SetSbVol ( nKanal, aVolume )


              /* No more, Mr.Nice Guy
                 -------------------- */
             CASE nKey == K_ESC

                 nEvent := EVENT_EXIT

             ENDCASE


        ENDCASE

     ENDDO

     ScrRest ( cScreen )

  RETURN ( nil )

  /* SbMixer ENDP */
