
 /* SYSINIT.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


  #include "SOUNDVIS.CH"


/*
    INIT PROCEDURE ClipInit() -> nil                    
    CLipInit replaces a Clipper-Lib function, which     
    installs the default Errorhandler by calling        
    Errorsys() and then creating the public Getlist-    
    Array.                                              
    I don't like a PUBLIC Getlist ( would you ?), so    
    here we just call ErrorSys() and skip the creation  
    of the Getlist; instead we create a local Getlist   
    where we need one. This saves precious DGROUP mem   
    and helps to write local 'Blackbox' functions.      
    From now on, you have to include a                  
               LOCAL Getlist := {}                      
    in any function that uses GET'S. If you don't want  
    this, just delete the ANNOUCE SysInit Statement     
    ( and the Errorsys() call )                         
    Because this is a INIT PROCEDURE, we can be sure    
    that our Sound & Vision Init-Stuff will be called   
    before any other Clipper code ; and that's what we  
    need !                                              
  */


//   use the following statement only with Clipper 5.2 !!!

//   ANNOUNCE Sysinit

   INIT PROCEDURE ClipInit()

    /* Get Soundblaster's Environment Var */
   LOCAL SbStr := GETENV("BLASTER")

    /* Deafult's for the Sb Installation */
   LOCAL SbPort := 220, SbIRQ := 7, SbDma := 1

   LOCAL nMouse, lFont := .f. 

   LOCAL lSound := .f.

   LOCAL cMessage

   LOCAL aButton := {'~OK','~Cancel'}


   /* Install default Errorhandler */
      ErrorSys()

   /* Install our Mouse-event Driver */
      nMouse := Mse_Init()

   /* load S&V Font */
      lFont := SET_FONT ( 'SVFont.016' )


   /* Set Sound & Vision Sb-Parameters */
      IF ! EMPTY ( SbStr )

         SbPort := INT( VAL( SUBSTR( SbStr, AT( 'A', SbStr )+1, 3)))
         SbIRQ  := INT( VAL( SUBSTR( SbStr, AT( 'I', SbStr )+1, 2)))
         SbDma  := INT( VAL( SUBSTR( SbStr, AT( 'D', SbStr )+1, 2)))

      ENDIF

      lSound := SbInit( SbIrq, SbPort, SbDMA  )


   /* Everything fine ? */
      IF nMouse # 0

         cMessage := 'Mouse not installed'

         DO CASE
         CASE nMouse == 1
              cMessage := cMessage - ';CPU < 80286 not supported'
              QUIT

         CASE nMouse == 2
              cMessage := cMessage - ';No Vga/Ega-Adapter'

         CASE nMouse == 3
              cMessage := cMessage - ';Mousedriver not found'

         ENDCASE


         IF AlertBox(1,cMessage,aButton) == 2
            QUIT
         ENDIF


     ENDIF


     IF ! lFont
        IF AlertBox(1,'Font could not be installed !',aButton) == 2
           QUIT
        ENDIF

     ENDIF

     IF ! lSound

        IF AlertBox(1,'Soundcard could not be initialized !;'+;
                      'please correct IRQ/Port/DMA Setting.',aButton) == 2
           QUIT
        ENDIF

     ENDIF

  RETURN


