
 /* TBROWSE.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


  #include "SOUNDVIS.CH"
  #include "INKEY.CH"



/*
    MemBrowse ( nTrow, nLCol, nBRow, nRCol,;            
                   aArray, aMse, nStart ) -> nChoice    
    This Array-Tbrowser is used within DirBrowse.prg    
    and GET AS LISTBOX. It is a part of the Sound &     
    Vision Lib, but I included the Sourcecode to show   
    how to manage Tbrowse-Mousesupport and S&V          
    Scrollbars                                          
                                                        
  */

  FUNCTION MemBrowse ( nTRow, nLCol, nBRow, nRCol, aArray , aMse, nStart )

    LOCAL  nY, nX , nChoice := 0

    LOCAL  nMaxLen := LEN( aArray )

    LOCAL  nKey, nScan, cScanKey := '', cOldKey := ' '

    LOCAL  nMseRow, nMseCol

    LOCAL  oBrowse := TBrowseNew ( nTRow, nLCol, nBRow, nRCol-1 )

    LOCAL  oScroll := ScrollNew ( nTRow, nRCol, nBRow, 0 )


    DEFAULT nStart TO 1


/* Install Skipper for Arraybrowser
   -------------------------------- */
   oBrowse:Cargo := nStart
   oBrowse:goTopBlock := { || oBrowse:Cargo := 1 }
   oBrowse:goBottomBlock := { || oBrowse:Cargo := nMaxLen }
   oBrowse:SkipBlock := { | nSoll, nIst |;
                              nIst := MIN( MAX( nSoll, -oBrowse:Cargo+1 ),;
                                   nMaxLen-oBrowse:Cargo ),;
                                      oBrowse:Cargo += nIst, nIst }


/* Add Tbrowse - column
   -------------------- */
   oBrowse:AddColumn( TbColumnNew( , { || ' '+aArray [ oBrowse:Cargo ]+' '}))
   oBrowse:GetColumn(1):width := nRCol+1-nLCol



   DO WHILE .t.

   // Stabilize
   DO WHILE ! oBrowse:stabilize() .AND. (nKey := INKEY()) == 0 ;  ENDDO

   // All quiet ?
   IF oBrowse:stable

      // position ScrollPtr
         oScroll := ScrollPos ( oScroll, nTRow+1+ROUND((oBrowse:Cargo-1) / ;
                               (nMaxLen-1) * (oBrowse:RowCount-3), 0 ))

      Mse_Show(.t.)
      nKey := INKEY(0)
      Mse_Show(.f.)

   ENDIF


/* Mouses first
   ------------ */
   DO CASE
   CASE nKey == K_MOUSE
        nMseRow := MSE_Row()
        nMseCol := MSE_Col()


     // Valid Row ?
        DO CASE
        CASE Mse_Check ( nTRow, nLCol, nBRow, nRCol-1 )

          // New PromptColumn
             nMseCol := ( nMseRow-nTRow)+1
             oBrowse:RowPos := nMseCol
             oBrowse:RefreshAll()

          // stabilize obj ( to get a valid RowPos! )
             DO WHILE ! oBrowse:stabilize()
             ENDDO

          // Exit, if PromptCol valid
             IF oBrowse:RowPos == nMseCol
                nChoice := oBrowse:Cargo
                EXIT
             ENDIF

          // Scrollbar ?
        CASE ( nX := ScrollMse ( oScroll )) # 0

             DO CASE
             CASE nX == M_UP
                  oBrowse:up()

             CASE nX == M_DOWN
                  oBrowse:down()

               // First Scrollfield
             CASE nX == 1
                  oBRowse:goTop()

               // Last Scrollfield
             CASE nX == ( nBRow - nTRow-1)
                  oBrowse:goBottom()

             OTHERWISE
                  oBrowse:Cargo := ;
                          INT ((nMaxLen / (nBRow-nTrow - 1)) * nX )

                  oBrowse:RefreshAll()


             ENDCASE

          // CloseIcon ?
        CASE oMouseWin() = M_CLOSE
             nChoice := B_ESC
             EXIT

          // scan Mouse-Array
        CASE VALTYPE( aMse ) = 'A'

             nChoice := 0

             FOR nX := 1 TO LEN ( aMse )

                 IF Mse_Check ( aMse[nX, MSE_TROW], ;
                                aMse[nX, MSE_LCOL], ;
                                aMse[nX, MSE_BROW], ;
                                aMse[nX, MSE_RCOL]  )
                    nChoice :=  aMse[nX, MSE_RET]
                    EXIT

                 ENDIF

             NEXT

             IF nChoice # 0
                EXIT

             ENDIF

        ENDCASE


   CASE nKey == K_UP     ;  oBrowse:up()
   CASE nKey == K_DOWN   ;  oBrowse:down()
   CASE nKey == K_HOME   ;  oBrowse:goTop()
   CASE nKey == K_END    ;  oBrowse:goBottom()
   CASE nKey == K_PGUP   ;  oBrowse:pageUp()
   CASE nKey == K_PGDN   ;  oBrowse:pageDown()

   CASE nKey == K_ENTER  
        nChoice := oBrowse:Cargo  
        EXIT

   CASE nKey == K_LEFT .OR. nKey == K_SH_TAB
        nChoice := B_LEFT
        EXIT

   CASE nKey == K_RIGHT  .OR. nKey == K_TAB
        nChoice := B_RIGHT
        EXIT

   CASE nKey == K_ESC
        nChoice := B_ESC
        EXIT

   CASE ISALPHA (CHR (nKey))

        // A new try ?
        IF (cScanKey := UPPER( CHR( nKey))) # cOldKey
           cOldKey := cScanKey
           nX := 1

        ELSE
           nX := oBrowse:Cargo + 1

        ENDIF

        // let me see ..
        IF (nScan := ASCAN ( aArray,{|a|UPPER(a) = cScanKey }, nX )) > 0
           oBrowse:Cargo := nScan
           oBrowse:refreshAll()

        ENDIF

   ENDCASE

  ENDDO

   /* kill PromptBar */
  oBrowse:deHiLite()

   /* kill ScrollPtr */
  ScrollPos ( oScroll, 0 )

 
 RETURN ( nChoice )



/*
    ChoseBox  ( nTop, nLeft, nBottom, nRight,;          
                   aArray, nStart ) -> nChoice          
    Is the Source for the GET AS LISTBOX Window         
    It shows how easy it is to build up an Arraybrowser 
    with MouseSupport, Scrollbars and a Windows-like    
    look  ( if you own Sound & Vision, of course )      
  */

   FUNCTION ChoseBox ( nTop, nLeft, nBottom, nRight, aArray, nStart )

     LOCAL nX := 1
     LOCAL cColor := SETCOLOR ( 'N/W, +W/N')
     LOCAL cScreen


     // Default Parameters
     DEFAULT nTop    TO 10
     DEFAULT nLeft   TO 30
     DEFAULT nBottom TO nTop+10


     IF nRight == nil

       // get the longest string
       // ----------------------
       AEVAL ( aArray, { | a | nX := MAX( nX, LEN(a)) } )
       nRight := nLeft+nX+3

    ENDIF

    OPENWIN FROM nTop-1, nLeft-2 TO nBottom+1, nRight+1 ;
            TOPCOLOR 112                                ;
            WINCOLOR 112                                ;
            TYP WIN_GSINGLE                             ;
            SAVE TO cScreen


     // Start browsing
     nX := MemBrowse ( nTop, nLeft-1, nBottom, nRight , aArray,, nStart )


     // CleanUp
     ScrRest  ( cScreen )
     SetColor ( cColor  )


  RETURN ( nX )
